# Paramètre de type "variable"

Imaginons que la variable "my_variable" pré-existe. La valeur de la variable sera utilisé comme paramètre :

```
<param type="variable">my_variable</param>
```

[Les variables meneuses ou suiveuses](../variable/leadership.md) peuvent être utilisé sans soucis comme paramètre.

## Paramètre avec variable potentiellement non existante

Suivant le contexte une variable peut exister ou ne pas exister.

Un paramètre de type "variable" peut être "optional" :

```
<param type="variable" optional="True">unknow_variable</param>
```

Si la variable "unknow_variable" n'existe pas, le paramètre ne sera pas passé à la fonction.

Si maintenant on créé un nouveau dictionnaire en créant cette variable, la fonction sera exécuté avec le paramètre.

## Paramètre avec variable potentiellement désactivée

Si une variable est désactivé, l'utilisation de cette variable peut poser problème.

Il est possible de ne pas générer d'erreur si une variable est désactivé en utilisant le paramètre "propertyerror" :

```
<param type="variable" propertyerror="False">variable1</param>
```

Dans ce cas, si la variable est désactivé, le paramètre n'est jamais donnée à la fonction de destination.

## Paramètre avec variable dynamique

Il est possible de faire un calcul avec comme paramètre [une variable d'une famille dynamique](../family/auto.md) mais pour une suffix particulier.

Par exemple :

```
<param type="variable">vardynval1</param>
```

Dans ce cas, la valeur du paramètre de la fonction sera la valeur de la variable "vardyn" pour la famille ayant le suffix "val1".

Il peut être utile de récupérer la valeur du suffix dans la fonction, pour cela il suffit de mettre un paramètre de type suffix :

```
<param type="suffix"/>
```

Dans l'exemple précédent la valeur de ce paramètre sera "val1".
