# La gestion d'un port

## La balise port

La gestion des ports se fait dans un conteneur de [service](service.md).

La balise port permet d'associer un port à service :

```
<services>
    <service name="squid">
        <port>3128</port>
    </service>
</services>
```

Il est possible de choisir le protocole TCP ou UDP (TCP par défaut) :

```
<port protocol="udp">123</port>
```

## Les numéros de port dynamique

Il est possible également de définir le port dans une variable :

```
<services>
    <service name="squid">
        <port port_type="variable">my_variable</port>
    </service>
</services>
<variables>
    <variable name="my_variable" type="port">
        <value>123</value>
    </variable>
</variables>
```

Attention, la variable doit être de type "port".

## Désactiver le port

Il est possible de définir une [condition](../condition/README.md) de type "disabled_if_in" ou "disabled_if_not_in" sur une balise port :

```
<services>
    <service name="test">
        <port portlist="squid">3128</port>
    </service>
</services>
<variables>
    <family name="general">
        <variable name="condition" type="boolean"/>
    </family>
</variables>
<constraints>
    <condition name="disabled_if_in" source="condition">
        <param>False</param>
        <target type="portlist">squid</target>
    </condition>
</constraints>
```

Dans ce cas, tous les ports avec un attribut portlist à "squid" seront désactivé si la variable "condition" est False.
